#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>

#include <time.h>
#include <sys/times.h>


#define SAME 0



struct tms start_time;
struct tms end_time;




float DeltaTime (struct tms start, struct tms end)
{
  return ((float) ((end.tms_cutime - start.tms_cutime + end.tms_cstime -
                    start.tms_cstime) / 100.0));
}




int main(int nargs, char *args[]) 
{
  int i;
  char file_name[255];
  char domain_name[255];
  char dwdir[255];
  char output[255];
  char temp[255];
  float ttranslate = 0.0, tpreprocess = 0.0, tsearch = 0.0;  

  sprintf(dwdir, "%s", args[0]);
  while (dwdir[strlen(dwdir)-1] != '/')
     dwdir[strlen(dwdir)-1] = '\0'; 

  printf("DIR = %s", dwdir);

  for (i = 0; i < nargs; i++) 
    {
      if (strcmp(args[i], "-o") == SAME)
	strcpy(domain_name, args[++i]);
      else if (strcmp(args[i], "-f") == SAME)
	strcpy(file_name, args[++i]);
      else if (strcmp(args[i], "-out") == SAME)
	strcpy(output, args[++i]);
    }

  printf("\nDomain: %s\nProblem: %s\n\nLAMA...\n\n", domain_name, file_name);
  fflush(stdout);
  
  times(&start_time);
  
  sprintf(temp, "%slama/translate/translate.py %s %s", dwdir, domain_name, file_name);
  //printf("\nexecuting: %s", temp);
  system(temp);
  
  times(&end_time);
  ttranslate += DeltaTime(start_time, end_time);
  times(&start_time);

  sprintf(temp, "%slama/preprocess/preprocess < output_l.sas", dwdir); 
  system(temp);

  times(&end_time);
  tpreprocess += DeltaTime(start_time, end_time);
  times(&start_time);
  
  sprintf(temp, "%slama/search_pbp/release-search fFlLi %s < output_l", dwdir,output);
  system(temp);

  times(&end_time);
  tsearch += DeltaTime(start_time, end_time);

  printf("\nTranslate Time: %.2f\nPreprocess Time: %.2f\nSearch Time: %.2f\n\nTotal Time %.2f\n", ttranslate, tpreprocess, tsearch, ttranslate + tpreprocess + tsearch);
  fflush(stdout);

  return 0;

}
